A frog is crossing a river. The river is divided into x units and at each unit there may or may not exist a stone. The frog can jump on a stone, but it must not jump into the water.

Given a list of stones’ positions (in units) in sorted ascending order, determine if the frog is able to cross the river by landing on the last stone. Initially, the frog is on the first stone and assume the first jump must be 1 unit.

If the frog’s last jump was k units, then its next jump must be either k - 1, k, or k + 1 units. Note that the frog can only jump in the forward direction.

Note:

  • The number of stones is ≥ 2 and is < 1,100.
  • Each stone’s position will be a non-negative integer < 231.
  • The first stone’s position is always 0.

Example 1:

1
2
3
4
5
6
7
8
9
10
11
[0,1,3,5,6,8,12,17]
There are a total of 8 stones.
The first stone at the 0th unit, second stone at the 1st unit,
third stone at the 3rd unit, and so on...
The last stone at the 17th unit.
Return true. The frog can jump to the last stone by jumping
1 unit to the 2nd stone, then 2 units to the 3rd stone, then
2 units to the 4th stone, then 3 units to the 6th stone,
4 units to the 7th stone, and 5 units to the 8th stone.

Example 2:

1
2
3
4
[0,1,2,3,4,8,9,11]
Return false. There is no way to jump to the last stone as
the gap between the 5th and 6th stone is too large.


自己的做法,时间复杂度O($n^2$), 速度慢到令人发指了,不过是自己写出来,还是保留一下吧。

  1. dp[i][j] 指通过跳j units, 能不能到达第i块石头
  2. dp[i][j] = dp[pre][j] | dp[pre][j - 1] | dp[pre][j + 1], 其中j的范围是[1, i], 最小值是1很好理解。最大值i是每次都按最长的距离跳。从第i - 1块石头,跳到第i块石头,最长的距离为i.
  3. dp[0][0] = true, 因为本来就在第一块石头上。
  4. 遍历dp[n - 1][j],有值为true的,就说明能够成功。
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
public boolean canCross(int[] stones) {
if (stones == null || stones.length <= 1)
return true;
int n = stones.length;
boolean[][] dp = new boolean[n][n];
HashMap<Integer, Integer> map = new HashMap<>();
for (int i = 0; i < n; i++) {
map.put(stones[i], i);
}
dp[0][0] = true;
for (int i = 0; i < n; i++) {
for (int j = 1; j <= i; j++) {
if (map.containsKey(stones[i] - j)) {
int pre = map.get(stones[i] - j);
dp[i][j] = dp[pre][j] | dp[pre][j - 1];
if (j + 1 < i)
dp[i][j] |= dp[pre][j + 1];
}
}
}
for (int j = 0; j < n; j++) {
if (dp[n - 1][j] == true)
return true;
}
return false;
}